<?php

namespace FiloBlu\MappConnectorExtension\Observer;

use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;

/**
 * Class MappAdditionalData
 * @package FiloBlu\Newsletter\Observer
 */
class MappAdditionalData implements ObserverInterface
{

    /**
     * @var \FiloBlu\Newsletter\Model\SubscriberInfo
     */
    protected $_subscriberInfo;

    /**
     * MappAdditionalData constructor.
     * @param \FiloBlu\Newsletter\Model\SubscriberInfo $subscriberInfo
     */
    public function __construct(
        \FiloBlu\Newsletter\Model\SubscriberInfo $subscriberInfo
    )
    {
        $this->_subscriberInfo = $subscriberInfo;
    }

    /**
     * @param Observer $observer
     * @return void
     */
    public function execute(Observer $observer)
    {
        $subscriber_object = $observer->getResult();
        $result = $subscriber_object->getSubscriberData();

        $newsletter_additional_data = $this->_subscriberInfo->load($result['subscriberid']);
        $result = array_merge($result,$newsletter_additional_data->getData());
        unset(
            $result['subscriber_id'],
            $result['subscriberid'],
            $result['created_at'],
            $result['updated_at']
        );

        $subscriber_object->setSubscriberData($result);
    }

}